/**
Written by Chromation Systems utilizing G4P Library found at
http://www.lagers.org.uk/g4p/distribution/web/index.html

24 Sliders control the 24 Channels on the 24 Channel USB Board.

Built to be a basic example of what the 24 Channel USB board is capable
of. A full 8 channel RGB Version is in the works check the website or
Chromation Systems Instructables profile.

Set the sliders then press spacebar. The firmware uses a counter to
place all the data into its correct register. If any data less or
more than 24 bytes is sent, the firwmare will get out the values out
of alignment.

Serial connection will try to connect to COM2 if it is not available
then it will connect to COM1, since all my computers have COM1 as on-board
serial port, when I plug in the circuit, it assigns it to COM2 or higher.

====== www.ChromationSystems.com ========
*/


import guicomponents.*;
import processing.serial.*;


GWSlider sdr1, sdr2, sdr3, sdr4, sdr5, sdr6, sdr7, sdr8, sdr9, sdr10, sdr11, sdr12;
GWSlider sdr13, sdr14, sdr15, sdr16, sdr17, sdr18, sdr19, sdr20, sdr21, sdr22, sdr23, sdr24;

Serial myPort;  // Create object from Serial class
int val;        // Data received from the serial port
String portName;


void setup() 
{
  size(500, 520);

    // Simple default slider,
  // constructor is `Parent applet', the x, y position and length
  sdr1 = new GWSlider(this,45,20,160);
  sdr1.setTickColour(255);
  sdr1.setFontColour(255);
  sdr1.setValue(0); 
  sdr1.setRenderValueLabel(false);  

  sdr2 = new GWSlider(this,45,50,160);
  sdr2.setTickColour(255);
  sdr2.setFontColour(255);
  sdr2.setValue(0); 
  sdr2.setRenderValueLabel(false);  

  sdr3 = new GWSlider(this,45,80,160);
  sdr3.setTickColour(255);
  sdr3.setFontColour(255);
  sdr3.setValue(0); 
  sdr3.setRenderValueLabel(false); 

  sdr4 = new GWSlider(this,45,110,160);
  sdr4.setTickColour(255);
  sdr4.setFontColour(255);  
  sdr4.setValue(0); 
  sdr4.setRenderValueLabel(false);  

  sdr5 = new GWSlider(this,45,140,160);
  sdr5.setTickColour(255);
  sdr5.setFontColour(255);
  sdr5.setValue(0); 
  sdr5.setRenderValueLabel(false);  

  sdr6 = new GWSlider(this,45,170,160);
  sdr6.setTickColour(255);
  sdr6.setFontColour(255);    
  sdr6.setValue(0); 
  sdr6.setRenderValueLabel(false);  

  sdr7 = new GWSlider(this,45,200,160);
  sdr7.setTickColour(255);
  sdr7.setFontColour(255);
  sdr7.setValue(0); 
  sdr7.setRenderValueLabel(false);  

  sdr8 = new GWSlider(this,45,230,160);
  sdr8.setTickColour(255);
  sdr8.setFontColour(255);  
  sdr8.setValue(0); 
  sdr8.setRenderValueLabel(false);  

  sdr9 = new GWSlider(this,45,260,160);
  sdr9.setTickColour(255);
  sdr9.setFontColour(255);
  sdr9.setValue(0); 
  sdr9.setRenderValueLabel(false);  

  sdr10 = new GWSlider(this,45,290,160);
  sdr10.setTickColour(255);
  sdr10.setFontColour(255);    
  sdr10.setValue(0); 
  sdr10.setRenderValueLabel(false);  

  sdr11 = new GWSlider(this,45,320,160);
  sdr11.setTickColour(255);
  sdr11.setFontColour(255);
  sdr11.setValue(0); 
  sdr11.setRenderValueLabel(false);  
  
  sdr12 = new GWSlider(this,45,350,160);
  sdr12.setTickColour(255);
  sdr12.setFontColour(255);
  sdr12.setValue(0); 
  sdr12.setRenderValueLabel(false);  

  sdr13 = new GWSlider(this,300,20,160);
  sdr13.setTickColour(255);
  sdr13.setFontColour(255);
  sdr13.setValue(0); 
  sdr13.setRenderValueLabel(false);  

  sdr14 = new GWSlider(this,300,50,160);
  sdr14.setTickColour(255);
  sdr14.setFontColour(255);
  sdr14.setValue(0); 
  sdr14.setRenderValueLabel(false);    
  
  sdr15 = new GWSlider(this,300,80,160);
  sdr15.setTickColour(255);
  sdr15.setFontColour(255); 
  sdr15.setValue(0); 
  sdr15.setRenderValueLabel(false);  

  sdr16 = new GWSlider(this,300,110,160);
  sdr16.setTickColour(255);
  sdr16.setFontColour(255); 
  sdr16.setValue(0); 
  sdr16.setRenderValueLabel(false);  

  sdr17 = new GWSlider(this,300,140,160);
  sdr17.setTickColour(255);
  sdr17.setFontColour(255);  
  sdr17.setValue(0); 
  sdr17.setRenderValueLabel(false);  

  sdr18 = new GWSlider(this,300,170,160);
  sdr18.setTickColour(255);
  sdr18.setFontColour(255);
  sdr18.setValue(0); 
  sdr18.setRenderValueLabel(false);  

  sdr19 = new GWSlider(this,300,200,160);
  sdr19.setTickColour(255);
  sdr19.setFontColour(255); 
  sdr19.setValue(0); 
  sdr19.setRenderValueLabel(false);  

  sdr20 = new GWSlider(this,300,230,160);
  sdr20.setTickColour(255);
  sdr20.setFontColour(255);
  sdr20.setValue(0); 
  sdr20.setRenderValueLabel(false);  

  sdr21 = new GWSlider(this,300,260,160);
  sdr21.setTickColour(255);
  sdr21.setFontColour(255);
  sdr21.setValue(0); 
  sdr21.setRenderValueLabel(false);  

  sdr22 = new GWSlider(this,300,290,160);
  sdr22.setTickColour(255);
  sdr22.setFontColour(255);
  sdr22.setValue(0); 
  sdr22.setRenderValueLabel(false);  

  sdr23 = new GWSlider(this,300,320,160);
  sdr23.setTickColour(255);
  sdr23.setFontColour(255);  
  sdr23.setValue(0); 
  sdr23.setRenderValueLabel(false);  

  sdr24 = new GWSlider(this,300,350,160);
  sdr24.setTickColour(255);
  sdr24.setFontColour(255);
  sdr24.setValue(0); 
  sdr24.setRenderValueLabel(false);  


//will try to open the second COM Port first,
//if it is not available it will open COM1
 try {
  portName = Serial.list()[1]; //change the 1 to 2 or 3 for higher COM Ports
 }
catch (ArrayIndexOutOfBoundsException e) {
  portName = Serial.list()[0];
  }
  
  myPort = new Serial(this, portName, 9600);
  println(portName);
}

void draw() {
  background(0);
  textSize(18);
  text("T1:",20,40,0);
  text("T2:",20,70,0);
  text("T3:",20,100,0);
  text("T4:",20,130,0);
  text("T5:",20,160,0);
  text("T6:",20,190,0);
  text("T7:",20,220,0);
  text("T8:",20,250,0); 
  text("T9:",20,280,0);
  text("T10:",20,310,0);
  text("T11:",20,340,0);
  text("T12:",20,370,0); 
  
  text("T13:",270,40,0);
  text("T14:",270,70,0);   
  text("T15:",270,100,0);
  text("T16:",270,130,0); 
  text("T17:",270,160,0);
  text("T18:",270,190,0); 
  text("T19:",270,220,0);
  text("T20:",270,250,0);   
  text("T21:",270,280,0);   
  text("T22:",270,310,0);  
  text("T23:",270,340,0); 
  text("T24:",270,370,0);
  text("Press Space Bar to send the PWM Values",250,410,0);
   text("Created for Instructables by www.ChromationSystems.com \n For use with the 18F4550 based 24 Channel LED Controller \n RGB Software comming soon.",250,440,0);
}

void keyPressed() {

  if (key == 32) { //wait for spacebar to be pressed.

//below makes the values of 0 - 100 into
// 0 - 255 and then sends it in order.
myPort.write(round(sdr1.getValue()*2.55));
myPort.write(round(sdr2.getValue()*2.55));
myPort.write(round(sdr3.getValue()*2.55));
myPort.write(round(sdr4.getValue()*2.55));
myPort.write(round(sdr5.getValue()*2.55));
myPort.write(round(sdr6.getValue()*2.55));
myPort.write(round(sdr7.getValue()*2.55));
myPort.write(round(sdr8.getValue()*2.55));
myPort.write(round(sdr9.getValue()*2.55));
myPort.write(round(sdr10.getValue()*2.55));
myPort.write(round(sdr11.getValue()*2.55));
myPort.write(round(sdr12.getValue()*2.55));

myPort.write(round(sdr13.getValue()*2.55));
myPort.write(round(sdr14.getValue()*2.55));
myPort.write(round(sdr15.getValue()*2.55));
myPort.write(round(sdr16.getValue()*2.55));
myPort.write(round(sdr17.getValue()*2.55));
myPort.write(round(sdr18.getValue()*2.55));
myPort.write(round(sdr19.getValue()*2.55));
myPort.write(round(sdr20.getValue()*2.55));
myPort.write(round(sdr21.getValue()*2.55));
myPort.write(round(sdr22.getValue()*2.55));
myPort.write(round(sdr23.getValue()*2.55));
myPort.write(round(sdr24.getValue()*2.55));


  } 

}


