


void RefreshScreen()
{
  background(127);//make grey background
  image(backgroundImg, 0, 0); //redraw the background image

  textSize(18);
  noStroke();
  fill(0);
  //draw device info
  text("Device: "+DeviceName, 15, 5, 380, 100); 
  text(DeviceFirmware, 260, 5, 380, 100);   
  text("Port: "+portName, 420, 5, 380, 100);

//displays the sliders, and creates the colored indicator circle
  for (int i=0;i != Sliders.length;i++) 
  {
    Sliders[i].display();
    SelectedSlider=i;
    CalculateColor();
    fill(CalcColor);
    stroke(0);
    strokeWeight(2);

    if (i < 8) 
      ellipse(60, 80+(i*40), 25, 25);
    else 
      ellipse(350, 80+((i-8)*40), 25, 25);         
    noStroke();
  }    

  for (int i=0;i != Buttons.length;i++)Buttons[i].display();


  //display text labels for selectors
  textSize(18);
  for (int i=0;i != 16;i++)
  {
    if (i < 8) 
      text(i+1, 25, 85+(i*40));
    else 
      text(i+1, 310, 85+((i-8)*40));
  }
}//end function


void ToggleLiveMode()
{
  //Assuming the device is connected, this sends the command to enter LiveMode and wait for data transfer
  println("Sending Q, Cmd: 60, Enter LiveMode");
  SendRequest(); //checks if port is open, starts character exchange, sets request flag
  CmdByte=60;
  DataByte1=0;
  DataByte2=0;
}

void SettingsUp()
{
  //Assuming the device is connected, this sends the command to Increase the setting value, same as pushing the button
  println("Sending Q, Cmd: 90, Enter LiveMode");
  SendRequest(); //checks if port is open, starts character exchange, sets request flag
  CmdByte=91; //CMD code for settings up
  DataByte1=0;
  DataByte2=0;
}

void SettingsDown()
{
  //Assuming the device is connected, this sends the command to decrease the setting value
  println("Sending Q, Cmd: 91, Enter LiveMode");
  SendRequest(); //checks if port is open, starts character exchange, sets request flag
  CmdByte=91; //CMD code for settings down
  DataByte1=0;
  DataByte2=0;
}

void SendRequest()
{ 
  if (DeviceConnected==false) //this is set once the host sends connection request and the device acknowledges
  {
    println("Port Not Open");
    return;
  }
  else {
    println("Send Request");
    RequestSent=true; //serial_event checks to make sure a command is waiting when it recieves data
    myPort.write('q');
    myPort.write('Q');
    myPort.write('z');
  }//end else
}

void mousePressed()
{
  //on mouse press, check if any of the sliders were clicked


    for (int i=0;i != Buttons.length;i++)
  { 
    if (Buttons[i].over())
    { 
      //sets the button state, weather its blue or red
      Buttons[i].Selected =! Buttons[i].Selected;
      Buttons[i].display();    
      SelectedButton = i;

      switch(i)
      {
      case 0: //LiveMode
        ToggleLiveMode();       
        break; 
      case 1: //Color Cycle
        StreamSend =! StreamSend;
        if (StreamSend==true)
        {
          CascadeFlag=true;
          //fill PWM color arrays with required starting values
          //fill Sequence
          for (int x=0;x != LEDTotal;x++)
          {           
            RedPWM[x]=255;
            GreenPWM[x]=0;
            BluePWM[x]=0;
            Sequence[x]=1;
          }
        }          
        break;             
      case 2: //Open Color Gradient
        GradientOpen =! GradientOpen;
        if (GradientOpen)  image(gradientImg, 80, 65);
        else RefreshScreen();
        break;             
      case 3: //Setting Down
        SettingsDown();
        //this toggles off the LiveMode Button, when the pattern is changed livemode is turned off on the device
        Buttons[0].Selected = false;
        Buttons[0].display();    
        break;           
      case 4: //Setting Up
        SettingsUp();
        //this toggles off the LiveMode Button, when the pattern is changed livemode is turned off on the device
        Buttons[0].Selected = false;
        Buttons[0].display();    
        break;
      }
      return; //leave function
    }
  }//end for

  if (GradientOpen==true)
  {
    PressGradient();
    return;
  }


  for (int i=0;i != Sliders.length;i++)
  {
    if (Sliders[i].over())
    {
      SelectedSlider=i;
      GlobalDragging=true;//used in draw or equivilent function to check wether to update the sliders
    }
  }  

  if (mouseButton == RIGHT) println(mouseX+" - "+mouseY); //make shows pritns X - Y coordinates
}//end func



void mouseReleased()
{
  //when mouse is released, stop dragging the slider. Clear Global dragging and any dragging flags 
  Sliders[SelectedSlider].Dragging=false; //slider specific slider flag
  GlobalDragging=false;  //Global Flag


  //when a button with Toggle=false, the button will change color when pressed and will turn back
  // when it is released, this finds the button and makes the changes.
  for (int i=0;i != Buttons.length;i++)
  {
    if (Buttons[i].Selected==true && Buttons[i].Toggle==false)
    {
      Buttons[i].Selected=false;
      Buttons[i].display();
    }
  }//end for
}//end function



void PressGradient()
{
  image(gradientImg, 80, 65); 
  int myColor=get(mouseX, mouseY);
  image(markImg, mouseX-6, mouseY-6);  

  float myRed = myColor >> 16 & 0xFF; //convert colors to 8-bit
  float myGreen = myColor >> 8 & 0xFF;
  float myBlue = myColor & 0xFF;

  //println(int(myRed)+" - "+int(myGreen)+" - "+int(myBlue));

  RedPWM[LEDCounter]=int(myRed);
  GreenPWM[LEDCounter]=int(myGreen);
  BluePWM[LEDCounter]=int(myBlue);  

  if (LEDCounter != (LEDTotal-1)) LEDCounter++;
  else LEDCounter=0;

  SendLiveData();
}



