
void SetupHardware()
{ 
  //Sets up the software once the device has responded with its type and firmware version
  switch(HardwareID)
  {
    case 248: //24 Channel RGB Mode
      DeviceName=HWID[0];
      DeviceFirmware=FWV[FirmwareV];      
      LEDTotal=8;
      break;
     case 24: //24 Channel mono color LED mode
      DeviceName=HWID[1];
      DeviceFirmware=FWV[FirmwareV];      
      LEDTotal=24;
      break;
     case 160: //16 Channel in RGB Mode
      DeviceName=HWID[2];
      DeviceFirmware=FWV[FirmwareV];
      LEDTotal=16;
      break;
   case 11: //24 Channel in 8 RGB Mode - Demonstration Firmware
      DeviceName=HWID[0];
      DeviceFirmware=FWV[FirmwareV];
      LEDTotal=8;
    break;
    
    default:
      DeviceName="Default";
      break;
  }
}


void keyPressed() {

  if (key == 32) //spacebar toggles LiveMode
  { 
    Buttons[0].Selected =! Buttons[0].Selected;
    Buttons[0].display();   
    ToggleLiveMode();
  }
}

 
 
 
 //========= start classes ==============
 
 class Button
 {
  String Label;
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int bWidth;
  int bHeight;
  boolean Toggle;
  boolean Selected;
 
 
   Button(String iLabel, int ixpos, int iypos, int ibWidth, int ibHeight, boolean iToggle, boolean iSelected)
   {
    Label = iLabel; 
    xpos = ixpos;
    ypos = iypos;  
    bWidth = ibWidth;
    bHeight = ibHeight;
    Toggle = iToggle;
    Selected = iSelected;
   }
    
    void display()
    {
      strokeWeight(1);
      stroke(255);
 
      if(Selected==true)
      {
      fill(145,45,45); 
      rect(xpos,ypos,bWidth,bHeight);    
      }
      else       
      {
      fill(45,45,145);
      rect(xpos,ypos,bWidth,bHeight);      
      }
      
      fill(255); 
      textSize(12);
      text(Label,xpos+5, ypos+3, 100, 100);
      noStroke();
      
    }
    
    
  boolean over() 
  { //checks of the mouse is over the slider, doesn't have to be on the handle
   if( mouseX >= xpos && mouseX <= xpos+bWidth && mouseY >= ypos && mouseY <= ypos+bHeight) 
    {      
      return true;
    } 
    else {
      return false;
    }
  }
  
  
 } 
 
 
//custom slider class, use it however you want, download and details at www.chromationsystems.com/sliderbars.html
class SliderBar
{
  int xpos; // rect xposition  
  int ypos ; // rect yposition
  int Slwidth; // single bar Slwidthth
  int Slheight; // rect height
  int Value; 
  int Minimum; 
  int Maximum;
  color BgColor;
  color SlColor;
  color SelColor; 
  color StrokeColor;
  boolean CircleHandle;  
  boolean Dragging;


//local variables 
  boolean over = false;

//gotta move the int variables into float variables
  float temp1=Slwidth;
  float temp2=Maximum;
  float temp3=Value;
  float temp4=Minimum;
  float MathVar=0;


  SliderBar(int ixp, int iyp, int iw,  int ih,  int iValue, int iMin, int iMax, color iBgColor, color iSlColor, color iSelColor, color iStrokeColor, boolean iCircleHandle, boolean iDragging) 
  {   
    xpos = ixp;
    ypos = iyp;  
    Slwidth = iw;
    Slheight = ih;
    Value=iValue;
    Maximum=iMax;
    Minimum=iMin;
    BgColor=iBgColor;
    SlColor=iSlColor;
    SelColor=iSelColor;
    StrokeColor=iStrokeColor;
    CircleHandle=iCircleHandle;     
    Dragging=iDragging;
  }
 
  void move () 
  {
   //this function handles position of the slider's handle
   
   temp1 = Slwidth;   
   temp3 = Value;
   temp4 = Minimum;
   
   MathVar = (((mouseX-xpos) / temp1)-1) *-1; //creates a scale factor based on mouse position 
                                              //relative to slider position
   MathVar = Maximum - (MathVar*(Maximum-Minimum));   
  
   if(MathVar > Maximum) { //check so it doesn't drag off the end
   MathVar=Maximum;
   }
   
  if(MathVar < Minimum) { //check so it doesn't drag off the end
   MathVar=Minimum;
  }  
  
   Value=int(MathVar); //set the value based on mouse movement
  }
 
 
  void display() 
  {
  stroke(StrokeColor);
  strokeWeight(1);

//circle handles are displayed differently so there are if/else statements to set it correctly

  fill(BgColor); //covers up the old slider with a blank rectangle, BgColor set in declaration
  rect(xpos,ypos,Slwidth,Slheight);   
  
  if(CircleHandle==true) temp1 = Slwidth -Slheight;
  else temp1=Slwidth-(Slwidth/20);
  
  temp2=Maximum;  //move variables into float
  temp3=Value;    //or do they don't compute correctly
  temp4 = Minimum;

  float MathVar;
  
  if(CircleHandle==true)
    MathVar = temp1 / (temp2 - temp4) * (temp3-temp4) + Slheight/2;
  else  
    MathVar = temp1 / (temp2 - temp4) * (temp3-temp4); 
//MathVar = (SlWidth / (Max / Min) * (Value - Minimum)
    
   fill(color(SelColor)); //draws the Selcolor over the selected area
   rect(xpos,ypos,MathVar,Slheight);
   
   fill(SlColor); //places the slider handle
   if(CircleHandle==true)   ellipse(xpos+MathVar,ypos+(Slheight/2),Slheight,Slheight); //Circle instead of rectangle
   else   rect((xpos+MathVar),ypos,Slwidth/20,Slheight); //and comment this line for circle
  }
  
  boolean over() 
  { //checks of the mouse is over the slider, doesn't have to be on the handle
   if( mouseX >= xpos && mouseX <= xpos+Slwidth && mouseY >= ypos && mouseY <= ypos+Slheight) 
    {      
      Dragging=true;
      over = true;
      return true;
    } 
    else {
      over = false;
      return false;
    }
  }
}
