 typedef signed char   int8; 
 typedef signed short  int16; 
 typedef signed long   int32; 
 typedef unsigned char  uint8; 
 typedef unsigned short  uint16; 
 typedef unsigned long  uint32; 

    /** BIt Defination ) ******************/

typedef union tag16FLAGS { 
    unsigned int asByte;        // allows access to the full 16 bits 
    struct tag16BITS { 
  unsigned b0:1;    
  unsigned b1:1;    
  unsigned b2:1;    
  unsigned b3:1;
  unsigned b4:1;  
  unsigned b5:1;    
  unsigned b6:1;
  unsigned b7:1;
  unsigned b8:1;    
  unsigned b9:1;    
  unsigned b10:1;    
  unsigned b11:1;
  unsigned b12:1;  
  unsigned b13:1;    
  unsigned b14:1;
  unsigned b15:1;    
    }; 
} T16_FLAGS; 



typedef union tag8FLAGS { 
    unsigned char asByte;        // allows access to the full 8 bits 
    struct tag8BITS { 
  unsigned b0:1;    
  unsigned b1:1;    
  unsigned b2:1;    
  unsigned b3:1;
  unsigned b4:1;  
  unsigned b5:1;    
  unsigned b6:1;
  unsigned b7:1;
    }; 
} T8_FLAGS; 


T8_FLAGS Flags;
T8_FLAGS Flags2;
T8_FLAGS Flags3;
T8_FLAGS Flags4;
T8_FLAGS computeByte;
T8_FLAGS cycleByte;


#if defined(__18F4550)
T8_FLAGS  FrameFirst; 
T8_FLAGS  RedFlags; 
T8_FLAGS  GreenFlags; 
T8_FLAGS  BlueFlags; 
T8_FLAGS  CycleFlags; 
T8_FLAGS MultiSwap; 
T8_FLAGS MultiStall;
#elif defined(__18F2550)
//need to be 16 bit wide
T16_FLAGS  FrameFirst; 
T16_FLAGS  RedFlags; 
T16_FLAGS  GreenFlags; 
T16_FLAGS  BlueFlags; 
T16_FLAGS  CycleFlags; 
T16_FLAGS MultiSwap;
T16_FLAGS MultiStall;
#endif


#define Flag1 Flags.b0
#define Flag2  Flags.b1
#define MultiUploadFlag Flags.b2
#define FlagCmdLiveUpload Flags.b3
#define FlagCmdPatternNum Flags.b4
#define FlagCmdUpload Flags.b5
#define DeviceConnected Flags.b6
#define LiveMode Flags.b7

#define FlagRestartPatt Flags2.b0
#define FlagPauseCycle Flags2.b1
#define DataConfirm Flags2.b2
#define MultiRollOver Flags2.b3
#define SetMultiFlag Flags2.b4
#define MultiFlag Flags2.b5
#define MultiHOLD Flags2.b6
#define FillArrays Flags2.b7


#define RandomColors Flags3.b0
#define ChangeFlag Flags3.b1
#define DemoMode Flags3.b2
#define FlagSettingUpload Flags3.b3
#define SettingsFirst Flags3.b4
#define DemoUpload Flags3.b5
#define SlideFirst Flags3.b6
#define WasLive Flags3.b7


#define waitingForXLAT Flags4.b1
#define updatePending Flags4.b2
#define ToggleFlag Flags4.b3
#define BounceFlag Flags4.b4
#define PackTheData Flags4.b5

#pragma idata sect0=0x060 //3 registers left

	char USB_Out_Buffer[CDC_DATA_OUT_EP_SIZE]=
{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3};

	char input_buffer[16]; 
	
	unsigned char  NextUSBOut=0;


	unsigned char LEDnum = 0;
	unsigned char x;
	unsigned char q;
	unsigned char NewBuffer = 0;
	unsigned char nextFrameVar= 0;
	unsigned char PatternMax=0;
	unsigned char PWMPeriod = 0;
	unsigned char uploadCounter =0;
	unsigned char uploadRollover=0;
	unsigned char TempFrame=0;
	
	int i=0;

	int CycleTimer=10; // was short long = -8,388,608 to 8,388,607
	int CycleTimerHold=10;

	unsigned char Mode = 0;

	unsigned char SwCount = 1;

	unsigned char Buffer1=0;
	unsigned char Buffer2=0;
	unsigned char Buffer3=0;
	
	
	unsigned char DataSkip=0;
	unsigned char DataPart=0;


	unsigned char RedVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 
	unsigned char GreenVal[16];//l[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 
	unsigned char BlueVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //goes into RAM registers same as 

	unsigned char RedHoldVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char GreenHoldVal[16];//[] ={0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
	unsigned char BlueHoldVal[16];//[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

//USE THIS DATA SPACE
//	unsigned char CycleCounter[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; //counts the cycles


#pragma idata sect1=0x100

	unsigned char SendArray[]={0, 0, 0, 0, 0, 0, 0, 0}; //variables for sending RAM data

	unsigned char uploadStr[72];//={3};
//{3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3};


const rom unsigned char BtChk[] = { 0b00000001,0b00000010,0b00000100,0b00001000,
0b00010000,0b00100000,0b01000000,0b10000000 };
const rom unsigned char LEDTotal=8;
const rom unsigned char LEDTotalm=7;



